diff --git a/src/vbox/vbox_tmpl.c b/src/vbox/vbox_tmpl.c
index 3208f03..0e829e3 100644
--- a/src/vbox/vbox_tmpl.c
+++ b/src/vbox/vbox_tmpl.c
@@ -42,7 +42,9 @@
 #include "domain_conf.h"
 #include "network_conf.h"
 #include "virterror_internal.h"
+#include "domain_event.h"
 #include "uuid.h"
+#include "event.h"
 #include "memory.h"
 #include "nodeinfo.h"
 #include "logging.h"
@@ -51,11 +53,10 @@
 /* This one changes from version to version. */
 #if VBOX_API_VERSION == 2002
 # include "vbox_CAPI_v2_2.h"
-/* Commented for now, v2.5 is far far away */
-/*
-#elif VBOX_API_VERSION == 2005
-# include "VBoxCAPI_v2_5.h"
-*/
+#elif VBOX_API_VERSION == 3000
+# include "vbox_CAPI_v3_0.h"
+#else
+# error "Unsupport VBOX_API_VERSION"
 #endif
 
 /* Include this *last* or we'll get the wrong vbox_CAPI_*.h. */
@@ -68,6 +69,33 @@
         virReportErrorHelper(conn, VIR_FROM_VBOX, code, __FILE__, \
                             __FUNCTION__, __LINE__, fmt)
 
+#define DEBUGPRUnichar(strUtf16) \
+if (strUtf16) {\
+    char *strUtf8 = NULL;\
+\
+    g_pVBoxGlobalData->pFuncs->pfnUtf16ToUtf8(strUtf16, &strUtf8);\
+    if (strUtf8) {\
+        DEBUG("%s: %s", #strUtf16, strUtf8);\
+        g_pVBoxGlobalData->pFuncs->pfnUtf8Free(strUtf8);\
+    }\
+}
+
+#define DEBUGUUID(iid) \
+{\
+    DEBUG (#iid ": {%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x}",\
+          (unsigned)(iid)->m0,\
+          (unsigned)(iid)->m1,\
+          (unsigned)(iid)->m2,\
+          (unsigned)(iid)->m3[0],\
+          (unsigned)(iid)->m3[1],\
+          (unsigned)(iid)->m3[2],\
+          (unsigned)(iid)->m3[3],\
+          (unsigned)(iid)->m3[4],\
+          (unsigned)(iid)->m3[5],\
+          (unsigned)(iid)->m3[6],\
+          (unsigned)(iid)->m3[7]);\
+}\
+
 typedef struct {
     virMutex lock;
     int version;
@@ -80,13 +108,57 @@ typedef struct {
 
     /** Our version specific API table pointer. */
     PCVBOXXPCOM pFuncs;
+
+#if VBOX_API_VERSION == 2002
+
+} vboxGlobalData;
+
+#else /* !(VBOX_API_VERSION == 2002) */
+
+    /* An array of callbacks */
+    virDomainEventCallbackListPtr domainEventCallbacks;
+    virDomainEventQueuePtr domainEventQueue;
+
+    int domainEventTimer;
+    int domainEventDispatching;
+
+    IVirtualBoxCallback *vboxCallback;
+
+    nsIEventQueue  *vboxQueue;
+    int volatile vboxCallBackRefCount;
+
+    /* pointer back to the connection */
+    virConnectPtr conn;
+
 } vboxGlobalData;
 
+/* g_pVBoxGlobalData has to be global variable,
+ * there is no other way to make the callbacks
+ * work other then having g_pVBoxGlobalData as
+ * global, because the functions namely AddRef,
+ * Release, etc consider it as global and you
+ * can't change the function definition as it
+ * is XPCOM nsISupport::* function and it expects
+ * them that way
+ */
+
+vboxGlobalData *g_pVBoxGlobalData = NULL;
+
+#endif /* !(VBOX_API_VERSION == 2002) */
 
 static virDomainPtr vboxDomainDefineXML(virConnectPtr conn, const char *xml);
 static int vboxDomainCreate(virDomainPtr dom);
 static int vboxDomainUndefine(virDomainPtr dom);
 
+static void vboxDriverLock(vboxGlobalData *data) {
+    virMutexLock(&data->lock);
+}
+
+static void vboxDriverUnlock(vboxGlobalData *data) {
+    virMutexUnlock(&data->lock);
+}
+
+#if VBOX_API_VERSION == 2002
 static void nsIDtoChar(unsigned char *uuid, const nsID *iid) {
     char uuidstrsrc[VIR_UUID_STRING_BUFLEN];
     char uuidstrdst[VIR_UUID_STRING_BUFLEN];
@@ -127,14 +199,6 @@ static void nsIDtoChar(unsigned char *uuid, const nsID *iid) {
     virUUIDParse(uuidstrdst, uuid);
 }
 
-static void vboxDriverLock(vboxGlobalData *data) {
-    virMutexLock(&data->lock);
-}
-
-static void vboxDriverUnlock(vboxGlobalData *data) {
-    virMutexUnlock(&data->lock);
-}
-
 static void nsIDFromChar(nsID *iid, const unsigned char *uuid) {
     char uuidstrsrc[VIR_UUID_STRING_BUFLEN];
     char uuidstrdst[VIR_UUID_STRING_BUFLEN];
@@ -174,6 +238,7 @@ static void nsIDFromChar(nsID *iid, const unsigned char *uuid) {
     virUUIDParse(uuidstrdst, uuidinterim);
     memcpy(iid, uuidinterim, VIR_UUID_BUFLEN);
 }
+#endif /* !(VBOX_API_VERSION == 2002) */
 
 static virCapsPtr vboxCapsInit(void) {
     struct utsname utsname;
@@ -225,10 +290,25 @@ static int vboxInitialize(virConnectPtr conn, vboxGlobalData *data) {
 
 #if VBOX_XPCOMC_VERSION == 0x00010000U
     data->pFuncs->pfnComInitialize(&data->vboxObj, &data->vboxSession);
-#else
+#else  /* !(VBOX_XPCOMC_VERSION == 0x00010000U) */
     data->pFuncs->pfnComInitialize(IVIRTUALBOX_IID_STR, &data->vboxObj,
                                ISESSION_IID_STR, &data->vboxSession);
-#endif
+
+#if VBOX_API_VERSION == 2002
+
+    /* No event queue functionality in 2.2.* as of now */
+
+#else  /* !(VBOX_API_VERSION == 2002) */
+
+    data->pFuncs->pfnGetEventQueue(&data->vboxQueue);
+
+    if (data->vboxQueue == NULL) {
+        vboxError(conn, VIR_ERR_INTERNAL_ERROR, "nsIEventQueue object is null");
+        goto cleanup;
+    }
+
+#endif /* !(VBOX_API_VERSION == 2002) */
+#endif /* !(VBOX_XPCOMC_VERSION == 0x00010000U) */
 
     if (data->vboxObj == NULL) {
         vboxError(conn, VIR_ERR_INTERNAL_ERROR, "IVirtualBox object is null");
@@ -290,6 +370,11 @@ static void vboxUninitialize(vboxGlobalData *data) {
 
     virDomainObjListFree(&data->domains);
     virCapabilitiesFree(data->caps);
+#if VBOX_API_VERSION == 2002
+    /* No domainEventCallbacks in 2.2.* version */
+#else  /* !(VBOX_API_VERSION == 2002) */
+    VIR_FREE(data->domainEventCallbacks);
+#endif /* !(VBOX_API_VERSION == 2002) */
     VIR_FREE(data);
 }
 
@@ -348,6 +433,22 @@ static virDrvOpenStatus vboxOpen(virConnectPtr conn,
         return VIR_DRV_OPEN_ERROR;
     }
 
+#if VBOX_API_VERSION == 2002
+
+    /* No domainEventCallbacks in 2.2.* version */
+
+#else  /* !(VBOX_API_VERSION == 2002) */
+
+    if (VIR_ALLOC(data->domainEventCallbacks) < 0) {
+        virReportOOMError(conn);
+        return VIR_DRV_OPEN_ERROR;
+    }
+
+    data->conn = conn;
+    g_pVBoxGlobalData = data;
+
+#endif /* !(VBOX_API_VERSION == 2002) */
+
     conn->privateData = data;
     DEBUG0("in vboxOpen");
 
@@ -455,7 +556,13 @@ static int vboxListDomains(virConnectPtr conn, int *ids, int nids) {
                 machine->vtbl->GetAccessible(machine, &isAccessible);
                 if (isAccessible) {
                     machine->vtbl->GetState(machine, &state);
-                    if ((state == MachineState_Running) ||
+                    if ((state == MachineState_Starting)   ||
+                        (state == MachineState_Running)    ||
+                        (state == MachineState_Stuck)      ||
+                        (state == MachineState_Stopping)   ||
+                        (state == MachineState_Saving)     ||
+                        (state == MachineState_Restoring)  ||
+                        (state == MachineState_Discarding) ||
                         (state == MachineState_Paused) ) {
                         ret++;
                         ids[j++] = i + 1;
@@ -504,7 +611,13 @@ static int vboxNumOfDomains(virConnectPtr conn) {
                 machine->vtbl->GetAccessible(machine, &isAccessible);
                 if (isAccessible) {
                     machine->vtbl->GetState(machine, &state);
-                    if ((state == MachineState_Running) ||
+                    if ((state == MachineState_Starting)   ||
+                        (state == MachineState_Running)    ||
+                        (state == MachineState_Stuck)      ||
+                        (state == MachineState_Stopping)   ||
+                        (state == MachineState_Saving)     ||
+                        (state == MachineState_Restoring)  ||
+                        (state == MachineState_Discarding) ||
                         (state == MachineState_Paused) ) {
                         ret++;
                     }
@@ -554,7 +667,12 @@ static virDomainPtr vboxDomainLookupByID(virConnectPtr conn, int id) {
     IMachine **machines  = NULL;
     PRUint32 machineCnt  = 0;
     virDomainPtr dom     = NULL;
+#if VBOX_API_VERSION == 2002
     nsID  *iid           = NULL;
+#else
+    PRUnichar *iidUtf16  = NULL;
+    char      *iidUtf8   = NULL;
+#endif
     unsigned char iidl[VIR_UUID_BUFLEN];
     PRUint32 state;
     int i;
@@ -582,16 +700,31 @@ static virDomainPtr vboxDomainLookupByID(virConnectPtr conn, int id) {
                 machines[id]->vtbl->GetAccessible(machines[id], &isAccessible);
                 if (isAccessible) {
                     machines[id]->vtbl->GetState(machines[id], &state);
-                    if ((state == MachineState_Running) ||
+                    if ((state == MachineState_Starting)   ||
+                        (state == MachineState_Running)    ||
+                        (state == MachineState_Stuck)      ||
+                        (state == MachineState_Stopping)   ||
+                        (state == MachineState_Saving)     ||
+                        (state == MachineState_Restoring)  ||
+                        (state == MachineState_Discarding) ||
                         (state == MachineState_Paused) ) {
                         PRUnichar *machineNameUtf16 = NULL;
-                        char *machineName;
+                        char      *machineNameUtf8  = NULL;
 
                         machines[id]->vtbl->GetName(machines[id], &machineNameUtf16);
-                        data->pFuncs->pfnUtf16ToUtf8(machineNameUtf16, &machineName);
+                        data->pFuncs->pfnUtf16ToUtf8(machineNameUtf16, &machineNameUtf8);
 
+#if VBOX_API_VERSION == 2002
                         machines[id]->vtbl->GetId(machines[id], &iid);
                         nsIDtoChar(iidl, iid);
+                        data->pFuncs->pfnComUnallocMem(iid);
+#else
+                        machines[id]->vtbl->GetId(machines[id], &iidUtf16);
+                        data->pFuncs->pfnUtf16ToUtf8(iidUtf16, &iidUtf8);
+                        virUUIDParse(iidUtf8, iidl);
+                        data->pFuncs->pfnUtf8Free(iidUtf8);
+                        data->pFuncs->pfnUtf16Free(iidUtf16);
+#endif
 
                         /* get a new domain pointer from virGetDomain, if it fails
                          * then no need to assign the id, else assign the id, cause
@@ -599,14 +732,13 @@ static virDomainPtr vboxDomainLookupByID(virConnectPtr conn, int id) {
                          * itself, so need not worry.
                          */
 
-                        dom = virGetDomain(conn, machineName, iidl);
+                        dom = virGetDomain(conn, machineNameUtf8, iidl);
                         if (dom)
                             dom->id = id + 1;
 
                         /* Cleanup all the XPCOM allocated stuff here */
-                        data->pFuncs->pfnComUnallocMem(iid);
-                        data->pFuncs->pfnUtf8Free(machineName);
-                        data->pFuncs->pfnComUnallocMem(machineNameUtf16);
+                        data->pFuncs->pfnUtf8Free(machineNameUtf8);
+                        data->pFuncs->pfnUtf16Free(machineNameUtf16);
                     }
                 }
             }
@@ -628,8 +760,13 @@ static virDomainPtr vboxDomainLookupByUUID(virConnectPtr conn, const unsigned ch
     IMachine **machines  = NULL;
     PRUint32 machineCnt  = 0;
     virDomainPtr dom     = NULL;
+#if VBOX_API_VERSION == 2002
     nsID  *iid           = NULL;
-    char *machineName    = NULL;
+#else
+    PRUnichar *iidUtf16  = NULL;
+    char      *iidUtf8   = NULL;
+#endif
+    char      *machineNameUtf8  = NULL;
     PRUnichar *machineNameUtf16 = NULL;
     unsigned char iidl[VIR_UUID_BUFLEN];
     int i, matched = 0;
@@ -652,10 +789,24 @@ static virDomainPtr vboxDomainLookupByUUID(virConnectPtr conn, const unsigned ch
             machine->vtbl->GetAccessible(machine, &isAccessible);
             if (isAccessible) {
 
+#if VBOX_API_VERSION == 2002
                 machine->vtbl->GetId(machine, &iid);
                 if (!iid)
                     continue;
                 nsIDtoChar(iidl, iid);
+                data->pFuncs->pfnComUnallocMem(iid);
+                iid = NULL;
+#else
+                machine->vtbl->GetId(machine, &iidUtf16);
+                if (!iidUtf16)
+                    continue;
+                data->pFuncs->pfnUtf16ToUtf8(iidUtf16, &iidUtf8);
+                virUUIDParse(iidUtf8, iidl);
+                data->pFuncs->pfnUtf8Free(iidUtf8);
+                data->pFuncs->pfnUtf16Free(iidUtf16);
+                iidUtf8  = NULL;
+                iidUtf16 = NULL;
+#endif
 
                 if (memcmp(uuid, iidl, VIR_UUID_BUFLEN) == 0) {
 
@@ -664,7 +815,7 @@ static virDomainPtr vboxDomainLookupByUUID(virConnectPtr conn, const unsigned ch
                     matched = 1;
 
                     machine->vtbl->GetName(machine, &machineNameUtf16);
-                    data->pFuncs->pfnUtf16ToUtf8(machineNameUtf16, &machineName);
+                    data->pFuncs->pfnUtf16ToUtf8(machineNameUtf16, &machineNameUtf8);
 
                     machine->vtbl->GetState(machine, &state);
 
@@ -674,25 +825,27 @@ static virDomainPtr vboxDomainLookupByUUID(virConnectPtr conn, const unsigned ch
                      * itself, so need not worry.
                      */
 
-                    dom = virGetDomain(conn, machineName, iidl);
+                    dom = virGetDomain(conn, machineNameUtf8, iidl);
                     if (dom)
-                        if ((state == MachineState_Running) ||
+                        if ((state == MachineState_Starting)   ||
+                            (state == MachineState_Running)    ||
+                            (state == MachineState_Stuck)      ||
+                            (state == MachineState_Stopping)   ||
+                            (state == MachineState_Saving)     ||
+                            (state == MachineState_Restoring)  ||
+                            (state == MachineState_Discarding) ||
                             (state == MachineState_Paused) )
                             dom->id = i + 1;
                 }
 
-                if (iid) {
-                    data->pFuncs->pfnComUnallocMem(iid);
-                    iid = NULL;
-                }
                 if (matched == 1)
                     break;
             }
         }
 
         /* Do the cleanup and take care you dont leak any memory */
-        if (machineName)
-            data->pFuncs->pfnUtf8Free(machineName);
+        if (machineNameUtf8)
+            data->pFuncs->pfnUtf8Free(machineNameUtf8);
         if (machineNameUtf16)
             data->pFuncs->pfnComUnallocMem(machineNameUtf16);
         for (i = 0; i < machineCnt; ++i) {
@@ -710,8 +863,13 @@ static virDomainPtr vboxDomainLookupByName(virConnectPtr conn, const char *name)
     IMachine **machines  = NULL;
     PRUint32 machineCnt  = 0;
     virDomainPtr dom     = NULL;
+#if VBOX_API_VERSION == 2002
     nsID  *iid           = NULL;
-    char *machineName    = NULL;
+#else
+    PRUnichar *iidUtf16  = NULL;
+    char      *iidUtf8   = NULL;
+#endif
+    char      *machineNameUtf8  = NULL;
     PRUnichar *machineNameUtf16 = NULL;
     unsigned char iidl[VIR_UUID_BUFLEN];
     int i, matched = 0;
@@ -735,16 +893,25 @@ static virDomainPtr vboxDomainLookupByName(virConnectPtr conn, const char *name)
             if (isAccessible) {
 
                 machine->vtbl->GetName(machine, &machineNameUtf16);
-                data->pFuncs->pfnUtf16ToUtf8(machineNameUtf16, &machineName);
+                data->pFuncs->pfnUtf16ToUtf8(machineNameUtf16, &machineNameUtf8);
 
-                if (machineName && (STREQ(name, machineName))) {
+                if (STREQ(name, machineNameUtf8)) {
 
                     PRUint32 state;
 
                     matched = 1;
 
+#if VBOX_API_VERSION == 2002
                     machine->vtbl->GetId(machine, &iid);
                     nsIDtoChar(iidl, iid);
+                    data->pFuncs->pfnComUnallocMem(iid);
+#else
+                    machine->vtbl->GetId(machine, &iidUtf16);
+                    data->pFuncs->pfnUtf16ToUtf8(iidUtf16, &iidUtf8);
+                    virUUIDParse(iidUtf8, iidl);
+                    data->pFuncs->pfnUtf8Free(iidUtf8);
+                    data->pFuncs->pfnUtf16Free(iidUtf16);
+#endif
 
                     machine->vtbl->GetState(machine, &state);
 
@@ -754,16 +921,22 @@ static virDomainPtr vboxDomainLookupByName(virConnectPtr conn, const char *name)
                      * itself, so need not worry.
                      */
 
-                    dom = virGetDomain(conn, machineName, iidl);
+                    dom = virGetDomain(conn, machineNameUtf8, iidl);
                     if (dom)
-                        if ((state == MachineState_Running) ||
+                        if ((state == MachineState_Starting)   ||
+                            (state == MachineState_Running)    ||
+                            (state == MachineState_Stuck)      ||
+                            (state == MachineState_Stopping)   ||
+                            (state == MachineState_Saving)     ||
+                            (state == MachineState_Restoring)  ||
+                            (state == MachineState_Discarding) ||
                             (state == MachineState_Paused) )
                             dom->id = i + 1;
                 }
 
-                if (machineName) {
-                    data->pFuncs->pfnUtf8Free(machineName);
-                    machineName = NULL;
+                if (machineNameUtf8) {
+                    data->pFuncs->pfnUtf8Free(machineNameUtf8);
+                    machineNameUtf8 = NULL;
                 }
                 if (machineNameUtf16) {
                     data->pFuncs->pfnComUnallocMem(machineNameUtf16);
@@ -775,8 +948,6 @@ static virDomainPtr vboxDomainLookupByName(virConnectPtr conn, const char *name)
         }
 
         /* Do the cleanup and take care you dont leak any memory */
-        if (iid)
-            data->pFuncs->pfnComUnallocMem(iid);
         for (i = 0; i < machineCnt; ++i) {
             if (machines[i])
                 machines[i]->vtbl->nsisupports.Release((nsISupports *)machines[i]);
@@ -790,21 +961,34 @@ static int vboxDomainSuspend(virDomainPtr dom) {
     nsresult rc;
     vboxGlobalData *data = dom->conn->privateData;
     IMachine *machine    = NULL;
+#if VBOX_API_VERSION == 2002
     nsID  *iid           = NULL;
+#else
+    PRUnichar *iidUtf16  = NULL;
+    char iidUtf8[VIR_UUID_STRING_BUFLEN];
+#endif
     IConsole *console    = NULL;
     PRUint32 state;
     int ret = -1;
 
+#if VBOX_API_VERSION == 2002
     if (VIR_ALLOC(iid) < 0) {
         virReportOOMError(dom->conn);
         goto cleanup;
     }
+#endif
 
     if (data->vboxObj) {
         PRBool isAccessible = PR_FALSE;
 
+#if VBOX_API_VERSION == 2002
         nsIDFromChar(iid, dom->uuid);
         rc = data->vboxObj->vtbl->GetMachine(data->vboxObj, iid, &machine);
+#else
+        virUUIDFormat(dom->uuid, iidUtf8);
+        data->pFuncs->pfnUtf8ToUtf16(iidUtf8, &iidUtf16);
+        rc = data->vboxObj->vtbl->GetMachine(data->vboxObj, iidUtf16, &machine);
+#endif
         if (NS_FAILED(rc)) {
             vboxError(dom->conn, VIR_ERR_INVALID_DOMAIN,
                             "no domain with matching id %d", dom->id);
@@ -820,7 +1004,11 @@ static int vboxDomainSuspend(virDomainPtr dom) {
 
             if (state == MachineState_Running) {
                  /* set state pause */
+#if VBOX_API_VERSION == 2002
                 data->vboxObj->vtbl->OpenExistingSession(data->vboxObj, data->vboxSession, iid);
+#else
+                data->vboxObj->vtbl->OpenExistingSession(data->vboxObj, data->vboxSession, iidUtf16);
+#endif
                 data->vboxSession->vtbl->GetConsole(data->vboxSession, &console);
                 if (console) {
                     console->vtbl->Pause(console);
@@ -844,7 +1032,11 @@ cleanup:
     if (machine)
         machine->vtbl->nsisupports.Release((nsISupports *)machine);
 
+#if VBOX_API_VERSION == 2002
     VIR_FREE(iid);
+#else
+    data->pFuncs->pfnUtf16Free(iidUtf16);
+#endif
     return ret;
 }
 
@@ -852,21 +1044,34 @@ static int vboxDomainResume(virDomainPtr dom) {
     nsresult rc;
     vboxGlobalData *data = dom->conn->privateData;
     IMachine *machine    = NULL;
+#if VBOX_API_VERSION == 2002
     nsID  *iid           = NULL;
+#else
+    PRUnichar *iidUtf16  = NULL;
+    char iidUtf8[VIR_UUID_STRING_BUFLEN];
+#endif
     IConsole *console    = NULL;
     PRUint32 state       = MachineState_Null;
     int ret = -1;
 
+#if VBOX_API_VERSION == 2002
     if (VIR_ALLOC(iid) < 0) {
         virReportOOMError(dom->conn);
         goto cleanup;
     }
+#endif
 
     if (data->vboxObj) {
         PRBool isAccessible = PR_FALSE;
 
+#if VBOX_API_VERSION == 2002
         nsIDFromChar(iid, dom->uuid);
         rc = data->vboxObj->vtbl->GetMachine(data->vboxObj, iid, &machine);
+#else
+        virUUIDFormat(dom->uuid, iidUtf8);
+        data->pFuncs->pfnUtf8ToUtf16(iidUtf8, &iidUtf16);
+        rc = data->vboxObj->vtbl->GetMachine(data->vboxObj, iidUtf16, &machine);
+#endif
         if (NS_FAILED(rc)) {
             vboxError(dom->conn, VIR_ERR_INVALID_DOMAIN,
                             "no domain with matching id %d", dom->id);
@@ -882,7 +1087,11 @@ static int vboxDomainResume(virDomainPtr dom) {
 
             if (state == MachineState_Paused) {
                  /* resume the machine here */
+#if VBOX_API_VERSION == 2002
                 data->vboxObj->vtbl->OpenExistingSession(data->vboxObj, data->vboxSession, iid);
+#else
+                data->vboxObj->vtbl->OpenExistingSession(data->vboxObj, data->vboxSession, iidUtf16);
+#endif
                 data->vboxSession->vtbl->GetConsole(data->vboxSession, &console);
                 if (console) {
                     console->vtbl->Resume(console);
@@ -906,7 +1115,11 @@ cleanup:
     if (machine)
         machine->vtbl->nsisupports.Release((nsISupports *)machine);
 
+#if VBOX_API_VERSION == 2002
     VIR_FREE(iid);
+#else
+    data->pFuncs->pfnUtf16Free(iidUtf16);
+#endif
     return ret;
 }
 
@@ -914,21 +1127,34 @@ static int vboxDomainShutdown(virDomainPtr dom) {
     nsresult rc;
     vboxGlobalData *data = dom->conn->privateData;
     IMachine *machine    = NULL;
+#if VBOX_API_VERSION == 2002
     nsID  *iid           = NULL;
+#else
+    PRUnichar *iidUtf16  = NULL;
+    char iidUtf8[VIR_UUID_STRING_BUFLEN];
+#endif
     IConsole *console    = NULL;
     PRUint32 state       = MachineState_Null;
     int ret = -1;
 
+#if VBOX_API_VERSION == 2002
     if (VIR_ALLOC(iid) < 0) {
         virReportOOMError(dom->conn);
         goto cleanup;
     }
+#endif
 
     if(data->vboxObj) {
         PRBool isAccessible = PR_FALSE;
 
+#if VBOX_API_VERSION == 2002
         nsIDFromChar(iid, dom->uuid);
         rc = data->vboxObj->vtbl->GetMachine(data->vboxObj, iid, &machine);
+#else
+        virUUIDFormat(dom->uuid, iidUtf8);
+        data->pFuncs->pfnUtf8ToUtf16(iidUtf8, &iidUtf16);
+        rc = data->vboxObj->vtbl->GetMachine(data->vboxObj, iidUtf16, &machine);
+#endif
         if (NS_FAILED(rc)) {
             vboxError(dom->conn, VIR_ERR_INVALID_DOMAIN,
                             "no domain with matching id %d", dom->id);
@@ -952,7 +1178,11 @@ static int vboxDomainShutdown(virDomainPtr dom) {
                 goto cleanup;
             }
 
+#if VBOX_API_VERSION == 2002
             data->vboxObj->vtbl->OpenExistingSession(data->vboxObj, data->vboxSession, iid);
+#else
+            data->vboxObj->vtbl->OpenExistingSession(data->vboxObj, data->vboxSession, iidUtf16);
+#endif
             data->vboxSession->vtbl->GetConsole(data->vboxSession, &console);
             if (console) {
                 console->vtbl->PowerButton(console);
@@ -967,7 +1197,11 @@ cleanup:
     if (machine)
         machine->vtbl->nsisupports.Release((nsISupports *)machine);
 
+#if VBOX_API_VERSION == 2002
     VIR_FREE(iid);
+#else
+    data->pFuncs->pfnUtf16Free(iidUtf16);
+#endif
     return ret;
 }
 
@@ -975,21 +1209,34 @@ static int vboxDomainReboot(virDomainPtr dom, unsigned int flags ATTRIBUTE_UNUSE
     nsresult rc;
     vboxGlobalData *data = dom->conn->privateData;
     IMachine *machine    = NULL;
+#if VBOX_API_VERSION == 2002
     nsID  *iid           = NULL;
+#else
+    PRUnichar *iidUtf16  = NULL;
+    char iidUtf8[VIR_UUID_STRING_BUFLEN];
+#endif
     IConsole *console    = NULL;
     PRUint32 state       = MachineState_Null;
     int ret = -1;
 
+#if VBOX_API_VERSION == 2002
     if (VIR_ALLOC(iid) < 0) {
         virReportOOMError(dom->conn);
         goto cleanup;
     }
+#endif
 
     if(data->vboxObj) {
         PRBool isAccessible = PR_FALSE;
 
+#if VBOX_API_VERSION == 2002
         nsIDFromChar(iid, dom->uuid);
         rc = data->vboxObj->vtbl->GetMachine(data->vboxObj, iid, &machine);
+#else
+        virUUIDFormat(dom->uuid, iidUtf8);
+        data->pFuncs->pfnUtf8ToUtf16(iidUtf8, &iidUtf16);
+        rc = data->vboxObj->vtbl->GetMachine(data->vboxObj, iidUtf16, &machine);
+#endif
         if (NS_FAILED(rc)) {
             vboxError(dom->conn, VIR_ERR_INVALID_DOMAIN,
                             "no domain with matching id %d", dom->id);
@@ -1004,7 +1251,11 @@ static int vboxDomainReboot(virDomainPtr dom, unsigned int flags ATTRIBUTE_UNUSE
             machine->vtbl->GetState(machine, &state);
 
             if (state == MachineState_Running) {
+#if VBOX_API_VERSION == 2002
                 data->vboxObj->vtbl->OpenExistingSession(data->vboxObj, data->vboxSession, iid);
+#else
+                data->vboxObj->vtbl->OpenExistingSession(data->vboxObj, data->vboxSession, iidUtf16);
+#endif
                 data->vboxSession->vtbl->GetConsole(data->vboxSession, &console);
                 if (console) {
                     console->vtbl->Reset(console);
@@ -1024,7 +1275,11 @@ cleanup:
     if (machine)
         machine->vtbl->nsisupports.Release((nsISupports *)machine);
 
+#if VBOX_API_VERSION == 2002
     VIR_FREE(iid);
+#else
+    data->pFuncs->pfnUtf16Free(iidUtf16);
+#endif
     return ret;
 }
 
@@ -1032,21 +1287,34 @@ static int vboxDomainDestroy(virDomainPtr dom) {
     nsresult rc;
     vboxGlobalData *data = dom->conn->privateData;
     IMachine *machine    = NULL;
+#if VBOX_API_VERSION == 2002
     nsID  *iid           = NULL;
+#else
+    PRUnichar *iidUtf16  = NULL;
+    char iidUtf8[VIR_UUID_STRING_BUFLEN];
+#endif
     IConsole *console    = NULL;
     PRUint32 state       = MachineState_Null;
     int ret = -1;
 
+#if VBOX_API_VERSION == 2002
     if (VIR_ALLOC(iid) < 0) {
         virReportOOMError(dom->conn);
         goto cleanup;
     }
+#endif
 
     if(data->vboxObj) {
         PRBool isAccessible = PR_FALSE;
 
+#if VBOX_API_VERSION == 2002
         nsIDFromChar(iid, dom->uuid);
         rc = data->vboxObj->vtbl->GetMachine(data->vboxObj, iid, &machine);
+#else
+        virUUIDFormat(dom->uuid, iidUtf8);
+        data->pFuncs->pfnUtf8ToUtf16(iidUtf8, &iidUtf16);
+        rc = data->vboxObj->vtbl->GetMachine(data->vboxObj, iidUtf16, &machine);
+#endif
         if (NS_FAILED(rc)) {
             vboxError(dom->conn, VIR_ERR_INVALID_DOMAIN,
                             "no domain with matching id %d", dom->id);
@@ -1066,12 +1334,28 @@ static int vboxDomainDestroy(virDomainPtr dom) {
                 goto cleanup;
             }
 
+#if VBOX_API_VERSION == 2002
             data->vboxObj->vtbl->OpenExistingSession(data->vboxObj, data->vboxSession, iid);
+#else
+            data->vboxObj->vtbl->OpenExistingSession(data->vboxObj, data->vboxSession, iidUtf16);
+#endif
             data->vboxSession->vtbl->GetConsole(data->vboxSession, &console);
             if (console) {
+
+#if VBOX_API_VERSION == 2002
                 console->vtbl->PowerDown(console);
+#else
+                IProgress *progress;
+                console->vtbl->PowerDown(console, &progress);
+#endif
                 console->vtbl->nsisupports.Release((nsISupports *)console);
                 ret = 0;
+
+#if VBOX_API_VERSION == 2002
+#else
+                if (progress)
+                    progress->vtbl->nsisupports.Release((nsISupports *)progress);
+#endif
             }
             data->vboxSession->vtbl->Close(data->vboxSession);
         }
@@ -1081,7 +1365,11 @@ cleanup:
     if (machine)
         machine->vtbl->nsisupports.Release((nsISupports *)machine);
 
+#if VBOX_API_VERSION == 2002
     VIR_FREE(iid);
+#else
+    data->pFuncs->pfnUtf16Free(iidUtf16);
+#endif
     return ret;
 }
 
@@ -1098,20 +1386,33 @@ static int vboxDomainSetMemory(virDomainPtr dom, unsigned long memory) {
     nsresult rc;
     vboxGlobalData *data = dom->conn->privateData;
     IMachine *machine    = NULL;
+#if VBOX_API_VERSION == 2002
     nsID  *iid           = NULL;
+#else
+    PRUnichar *iidUtf16  = NULL;
+    char iidUtf8[VIR_UUID_STRING_BUFLEN];
+#endif
     PRUint32 state       = MachineState_Null;
     int ret = -1;
 
+#if VBOX_API_VERSION == 2002
     if (VIR_ALLOC(iid) < 0) {
         virReportOOMError(dom->conn);
         goto cleanup;
     }
+#endif
 
     if(data->vboxObj) {
         PRBool isAccessible = PR_FALSE;
 
+#if VBOX_API_VERSION == 2002
         nsIDFromChar(iid, dom->uuid);
         rc = data->vboxObj->vtbl->GetMachine(data->vboxObj, iid, &machine);
+#else
+        virUUIDFormat(dom->uuid, iidUtf8);
+        data->pFuncs->pfnUtf8ToUtf16(iidUtf8, &iidUtf16);
+        rc = data->vboxObj->vtbl->GetMachine(data->vboxObj, iidUtf16, &machine);
+#endif
         if (NS_FAILED(rc)) {
             vboxError(dom->conn, VIR_ERR_INVALID_DOMAIN,
                             "no domain with matching id %d", dom->id);
@@ -1131,7 +1432,11 @@ static int vboxDomainSetMemory(virDomainPtr dom, unsigned long memory) {
                 goto cleanup;
             }
 
+#if VBOX_API_VERSION == 2002
             rc = data->vboxObj->vtbl->OpenSession(data->vboxObj, data->vboxSession, iid);
+#else
+            rc = data->vboxObj->vtbl->OpenSession(data->vboxObj, data->vboxSession, iidUtf16);
+#endif
             if (NS_SUCCEEDED(rc)) {
                 rc = data->vboxSession->vtbl->GetMachine(data->vboxSession, &machine);
                 if (NS_SUCCEEDED(rc) && machine) {
@@ -1155,7 +1460,11 @@ cleanup:
     if (machine)
         machine->vtbl->nsisupports.Release((nsISupports *)machine);
 
+#if VBOX_API_VERSION == 2002
     VIR_FREE(iid);
+#else
+    data->pFuncs->pfnUtf16Free(iidUtf16);
+#endif
     return ret;
 }
 
@@ -1275,7 +1584,12 @@ static int vboxDomainSave(virDomainPtr dom, const char *path ATTRIBUTE_UNUSED) {
     nsresult rc;
     vboxGlobalData *data = dom->conn->privateData;
     IConsole *console    = NULL;
-    nsID *iid            = NULL;
+#if VBOX_API_VERSION == 2002
+    nsID  *iid           = NULL;
+#else
+    PRUnichar *iidUtf16  = NULL;
+    char iidUtf8[VIR_UUID_STRING_BUFLEN];
+#endif
     int ret = -1;
 
     /* VirtualBox currently doesn't support saving to a file
@@ -1284,16 +1598,24 @@ static int vboxDomainSave(virDomainPtr dom, const char *path ATTRIBUTE_UNUSED) {
      * this behaviour once get the VirtualBox API in right
      * shape to do this
      */
+#if VBOX_API_VERSION == 2002
     if (VIR_ALLOC(iid) < 0) {
         virReportOOMError(dom->conn);
         goto cleanup;
     }
+#endif
 
     if(data->vboxObj) {
-        nsIDFromChar(iid, dom->uuid);
 
         /* Open a Session for the machine */
+#if VBOX_API_VERSION == 2002
+        nsIDFromChar(iid, dom->uuid);
         rc = data->vboxObj->vtbl->OpenExistingSession(data->vboxObj, data->vboxSession, iid);
+#else
+        virUUIDFormat(dom->uuid, iidUtf8);
+        data->pFuncs->pfnUtf8ToUtf16(iidUtf8, &iidUtf16);
+        rc = data->vboxObj->vtbl->OpenExistingSession(data->vboxObj, data->vboxSession, iidUtf16);
+#endif
         if (NS_SUCCEEDED(rc)) {
             rc = data->vboxSession->vtbl->GetConsole(data->vboxSession, &console);
             if (NS_SUCCEEDED(rc) && console) {
